{Exemplo de Leitura de cheques ou boletos
 usando a porta serial
}
unit ExApi_u;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    btFechar: TButton;
    StatusBar1: TStatusBar;
    Timer1: TTimer;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
    procedure btFecharClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  hComm: THandle;
  bRead: array[0..255] of byte;
  iRet: LongBool;

implementation
{
Objetivo: Abrir comunicao com a porta serial
Paramentros:
 NomePorta  =COM1,COM2,etc
 ConfigPorta=2400,o,7,1 ou 9600,n,8,2 etc
Retorno:
 True ou false
}
Function OpenComm(NomePorta, ConfigPorta: String):Boolean;
var BarDCB: DCB;
    LastError: Cardinal;
    CTimeOut: COMMTIMEOUTS;
begin
   hComm:=CreateFile(PChar(NomePorta),GENERIC_READ+GENERIC_WRITE,
                                0, //not shared
                                nil, //no security
                                OPEN_EXISTING,
                                FILE_ATTRIBUTE_NORMAL, //+FILE_FLAG_OVERLAPPED
                                0{template} );
    If hComm = INVALID_HANDLE_VALUE Then begin
        ShowMessage('Porta Serial ' + NomePorta + ' no disponvel. configure os paramentros da porta serial');
        Result:=False;
        Exit;
    End;
//  Configurar os Time Outs para a Porta
    CtimeOut.ReadIntervalTimeout:=20;
    CtimeOut.ReadTotalTimeoutConstant:=1;
    CtimeOut.ReadTotalTimeoutMultiplier:=1;
    CtimeOut.WriteTotalTimeoutConstant:=20;
    CtimeOut.WriteTotalTimeoutMultiplier:=1;
    iRet:=SetCommTimeouts(hComm, CTimeOut);
    If Ord(iRet)= -1 Then begin
        LastError:=GetLastError();
        ShowMessage('No  permitido configurar os Timeouts para esta porta ' + NomePorta + ' Erro: ' + Inttostr(LastError));
        CloseHandle(hComm);
        Result:=False;
        Exit;
    End;
    iRet:=BuildCommDCB(PChar(NomePorta+':'+ConfigPorta), BarDCB);
    If Ord(iRet)=-1 Then begin
        LastError:= GetLastError();
        ShowMessage('No  permitido montar os parametros da Porta' + ConfigPorta + ' Erro: ' + Inttostr(LastError));
        CloseHandle(hComm);
        Result:=False;
        Exit;
    End;
    iRet:=SetCommState(hComm, BarDCB);
    If Ord(iRet)= -1 Then begin
        LastError:= GetLastError();
        ShowMessage('No  permitido configurar os parametros da Porta' + ConfigPorta + ' Erro: ' + Inttostr(LastError));
        CloseHandle(hComm);
        Result:=False;
        Exit;
    End;
    Result:=True;
End;
{
Objetivo: Fechar comunicao com a porta serial
Retorno:
 True ou false
}
Function CloseComm:Boolean;
begin
  Result:=CloseHandle(hComm);
End;
{
Objetivo: Limpar Buffer de Leitura e Escrita
}
Procedure FlushComm;
begin
  FlushFileBuffers(hComm);
End;
{
Objetivo: Limpar dados recebidos na porta serial
}
Procedure ClearReadComm;
begin
  PurgeComm(hComm,PURGE_RXCLEAR);
End;
{
Objetivo: Limpar dados enviados para porta serial
}
Procedure ClearSendComm;
begin
  PurgeComm(hComm,PURGE_TXCLEAR);
End;
{
Objetivo: Ler dados na Porta serial
Retorno:
 String
}
Function ReadComm:String;
var BytesLidos: DWord;
    i: Integer;
    ReadStr: String;
begin
  iRet:=ReadFile(hComm, bRead[0], 255, BytesLidos, nil);
  if ord(iRet)=-1 then exit;
  ReadStr:='';
//IF bytesLidos > 0 then ShowMessage(inttostr(BytesLidos));
  If BytesLidos > 0 Then
    For I:=0 To BytesLidos - 1  do
      ReadStr:=ReadStr + chr(bRead[i])
  Else
     FlushComm;
  Result:=ReadStr;
End;
{
Objetivo: Enviar dados para a porta serial
Paramentros:
 sComando = 'WBFHOSY'
 comando para configurar o leitor em 2400,o,7,1
 Modelo TL800 da empresa Tecsimi
Retorno:
 True ou false
}
Function SendComm(sComando: String):Integer;
var BytesEnviados: DWORD;
begin
  iRet:=WriteFile(hComm,PCHAR(sComando)[0],Length(sComando), BytesEnviados, nil);
  FlushComm;
  if iRet then Result:=BytesEnviados else Result:=-1;
End;
{FIM DAS FUNES DA API WINDOWS}
{$R *.DFM}

procedure TForm1.FormShow(Sender: TObject);
begin
  if OpenComm('Com1','2400,O,7,1') then begin
    StatusBar1.Panels[1].text:='Passe o documento para Leitura !';
    Timer1.Enabled:=True;
  end
  else begin
    StatusBar1.Panels[1].text:='No foi aberta a comunicao !';
    Timer1.Enabled:=False;
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Timer1.Enabled:=False;
  CloseComm;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var strLida: String;
begin
 strLida:=ReadComm;
 if length(StrLida)>0 then label1.Caption:=strLida;
end;

procedure TForm1.btFecharClick(Sender: TObject);
begin
  close;
end;

end.
